--
--  REG_ADDR.vhd
--
--  DECODER of Registre.
--
--        Copyright (C)2001 SEILEBOST
--                   All rights reserved.
--
-- $Id: REG_ADDR.vhd, v0.2 2001/11/02 00:00:00 SEILEBOST $
--

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;

entity REG_ADRESSE is
    Port ( BUS_DATA : in     std_logic_vector(3 downto 0);
           SEL_REG  : out    std_logic_vector(15 downto 0);
           A8       : in     std_logic;
           A9       : in     std_logic;
           Latch    : in     std_logic;
           CLK      : in     std_logic;
           RST      : in     std_logic);
end REG_ADRESSE;

architecture Behavioral of REG_ADRESSE is

-- DECODER 4 -> 16
begin

 process(CLK, RST, Latch)
 begin 

  if (RST = '1') then
     SEL_REG <= "0000000000000000";
  else
    if (LATCH = '1' and CLK'event and CLK ='1') then
          case BUS_DATA is
           when "0000" => SEL_REG <= "0000000000000001";
           when "0001" => SEL_REG <= "0000000000000010";
           when "0010" => SEL_REG <= "0000000000000100";
           when "0011" => SEL_REG <= "0000000000001000";
           when "0100" => SEL_REG <= "0000000000010000";
           when "0101" => SEL_REG <= "0000000000100000";
           when "0110" => SEL_REG <= "0000000001000000";
           when "0111" => SEL_REG <= "0000000010000000";
           when "1000" => SEL_REG <= "0000000100000000";
           when "1001" => SEL_REG <= "0000001000000000";
           when "1010" => SEL_REG <= "0000010000000000";
           when "1011" => SEL_REG <= "0000100000000000";
           when "1100" => SEL_REG <= "0001000000000000";
           when "1101" => SEL_REG <= "0010000000000000";
           when "1110" => SEL_REG <= "0100000000000000";
           when "1111" => SEL_REG <= "1000000000000000";
           when others => NULL;
          end case;
       end if;
  end if;
 end process;
end Behavioral;
