--
--  GEN_ENV.vhd
--
--  GENERATOR of ENVELOPE.
--
--        Copyright (C)2001 SEILEBOST
--                   All rights reserved.
--
-- $Id: GEN_ENV.vhd, v0.3 2001/11/14 00:00:00 SEILEBOST $
--

-- NO BUGS  
-- NEARLY TESTED

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity gen_env is
    Port ( CLK_ENV      : in      std_logic;
           DATA         : in      std_logic_vector(3 downto 0);
           RST          : in      std_logic;
           WR           : in      std_logic;
           CS           : in      std_logic;
           OUT_DATA     : inout   std_logic_vector(3 downto 0) );
end gen_env;

architecture Behavioral of gen_env is

SIGNAL COUNT : std_logic_vector(3 downto 0);
SIGNAL DIR   : std_logic;
SIGNAL HOLD  : std_logic;
begin


 PROCESS(CLK_ENV, RST)
 BEGIN
    if (RST = '1') then  -- Reset
       OUT_DATA <= "0000";
       COUNT    <= "1111";
       HOLD     <= '1';
       DIR      <= '1';
    elsif (CLK_ENV'event and CLK_ENV = '1') then -- edge clock
       if (WR = '1' AND CS = '1') then -- Write to register
          COUNT    <= "0000";
          HOLD     <= '0';
          DIR      <= DATA(2);
          if (DATA(2) = '0') then
             OUT_DATA <= "1111";
          else
             OUT_DATA <= "0000";
          end if;
       elsif (count = "1111") then  -- the treatment
             if (DATA(3) = '0') then
                OUT_DATA <= "0000";
                HOLD     <= '1';
             elsif (DATA(0) = '1') then  -- hold = 1
                   HOLD <= '1';
                   if (DATA(2) = DATA(1)) then
                      OUT_DATA <= "0000";
                   else 
                      OUT_DATA <= "1111";
                   end if;                        
             else
                   if (DATA(1) = '1') then
                      DIR <= not DIR;
                   else
                      if (DATA(2) = DATA(1)) then
                         OUT_DATA <= "0000";
                      else 
                         OUT_DATA <= "1111";
                      end if;
                   end if;
             end if;
             COUNT <= "0000";
       else
             COUNT <= COUNT + 1;             
             if (HOLD = '0') then                 
                if (DIR = '1') then 
                   OUT_DATA <= OUT_DATA + 1;
                else
                   OUT_DATA <= OUT_DATA - 1;
                end if;            
             end if;
       end if;
    end if; -- fin elsif
 END PROCESS;

end Behavioral;
